/*-
 * Copyright (c) 2009-2012 Juan Romero Pardines.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef _XBPS_REPO_DEFS_H_
#define _XBPS_REPO_DEFS_H_

#ifndef __UNCONST
#define __UNCONST(a)    ((void *)(unsigned long)(const void *)(a))
#endif

#include <xbps_api.h>

struct repo_search_data {
	int npatterns;
	char **patterns;
	size_t pkgver_len;
};

/* From index.c */
int	repo_genindex(const char *);

/* From index-files.c */
int	repo_genindex_files(const char *);

/* From find-files.c */
int	repo_find_files_in_packages(int, char **);

/* From list.c */
int	repo_pkg_list_cb(struct repository_pool_index *, void *, bool *);
int	repo_list_uri_cb(struct repository_pool_index *, void *, bool *);
int	repo_search_pkgs_cb(struct repository_pool_index *, void *, bool *);

/* From show.c */
int	show_pkg_info_from_repolist(const char *, const char *);
int	show_pkg_deps_from_repolist(const char *);
int 	show_pkg_namedesc(prop_object_t, void *, bool *);


#endif /* !_XBPS_REPO_DEFS_H_ */
